#ifndef CHARYBDISFPYTHIA_HH 
#define CHARYBDISFPYTHIA_HH 

#include "AGILe/Generator.hh"
#include "AGILe/Charybdis/CharybdisWrapper.hh"
#include "AGILe/FPythia/FPythia.hh"


namespace AGILe {

  /// Abstract base class for Charybdis interface
  /// @author Doug Gingrich
  /// @author Andy Buckley
  /// @date   2007-10-16
  class CharybdisFPythia : public FPythia {
  public:
    /// Standard constructor.
    CharybdisFPythia();
    
    /// Destructor.
    ~CharybdisFPythia() { }

    /// Make sure that generic setParam is visible.
    using FPythia::setParam;

    /// Pass a parameter to the generator.
    Status setParam(const string& name, const string& value);
  };
  
}

#endif  
