// $Id: $
#ifndef RIVETGUN_GENERATORNAMES_HH 
#define RIVETGUN_GENERATORNAMES_HH 1

#include "RivetGun/RivetGun.hh"


namespace Rivet {

  /// Enumeration of known generator interfaces.
  enum GeneratorName {
    GEN_FHERWIG6507,
    GEN_FHERWIG6510,
    GEN_FPYTHIA6206,
    GEN_FPYTHIA6326,
    GEN_FPYTHIA6408,
    GEN_HERWIG
    GEN_SHERPA,
    GEN_PYTHIA
  };

  /// Typedef for a mapping from generator enum to name string.
  typedef map<GeneratorName, string> GeneratorMap;

  /// Typedef for a mapping from generator name string to enum.
  typedef map<string, GeneratorName> GeneratorMapR;

  /// Get GeneratorMap filled with all known generators.
  inline const GeneratorMap getKnownGenerators() {
    GeneratorMap gmap;
    gmap[GEN_FHERWIG6507] = "FHerwig6507";
    gmap[GEN_FHERWIG6510] = "FHerwig6510";
    gmap[GEN_FPYTHIA] = "FPythia6206";
    gmap[GEN_FPYTHIA] = "FPythia6326";
    gmap[GEN_FPYTHIA] = "FPythia6408";
    gmap[GEN_HERWIG] = "Herwig"; //++";
    gmap[GEN_SHERPA] = "Sherpa";
    gmap[GEN_PYTHIA] = "Pythia";
    return gmap;
  }

  /// Get GeneratorMapR filled with all known generators.
  inline const GeneratorMapR getKnownGeneratorsR() {
    throw runtime_error("RivetGun::getKnownGeneratorsR() is not yet implemented");
    return GeneratorMapR();
  }

}

#endif // RIVETGUN_GENERATORNAMES_HH
